﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Weather
{
    public class ParticleSystem
    {
        GraphicsDevice dev;

        public ParticleSystem(GraphicsDevice device)
        {
            dev = device;
        }

        /// <summary>
        /// Creates a empty sprite.
        /// </summary>
        /// <param name="width">width of the sprite</param>
        /// <param name="height">height of the sprite</param>
        /// <param name="color">color of the sprite</param>
        /// <returns>Texture2D</returns>
        public Texture2D CreateEmptySprite(int width, int height, Color color)
        {
            Texture2D tex = new Texture2D(dev, width, height, false, SurfaceFormat.Color);
            Color[] clr = new Color[width * height];
            for (int i = 0; i < clr.Length; i++)
            {
                clr[i] = color;
            }
            tex.SetData(clr);
            return tex;
        }
    }
}
