﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Weather
{
    public class Snow
    {
        public Vector2 pos { get; set; }
        public Rectangle rectanglePos { get; set; }
        public Texture2D tex { get; set; }
        public float rotationSpeed { get; set; }
        public int deleteAfterX { get; set; }
        public int deleteAfterY { get; set; }
        public float ySpeed { get; set; }
        public float xSpeed { get; set; }
        private float rotationSpeedSet;

        public Snow(Vector2 position, Texture2D texture, float RotationSpeed = 0.01f, int DeleteAfterX = 600, int DeleteAfterY = 800, float yspeed = 2f, float xspeed = 0.1f)
        {
            this.pos = position;
            this.tex = texture;
            this.rotationSpeedSet = RotationSpeed;
            this.deleteAfterX = DeleteAfterX;
            this.deleteAfterY = DeleteAfterY;
            this.ySpeed = yspeed;
            this.xSpeed = xspeed;
        }

        /// <summary>
        /// updates the snow
        /// </summary>
        public void Update()
        {
            //make the snow fall down
            this.pos = new Vector2(pos.X + xSpeed, pos.Y + ySpeed);

            //configure the rotation
            this.rotationSpeed = rotationSpeedSet + rotationSpeed;

            //reset the snow when needed
            if (pos.Y > deleteAfterY)
            {
                this.pos = new Vector2(pos.X, 0 - tex.Height);
            }
            if (pos.X > deleteAfterX)
            {
                this.pos = new Vector2(0 - tex.Width, pos.Y);
            }

            //set the rectangle
            rectanglePos = new Rectangle((int)pos.X, (int)pos.Y, tex.Width, tex.Height);
        }
    }
}
