﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Weather
{
    public class Wind
    {
        public Vector2 pos { get; set; }
        public Rectangle rectanglePos { get; set; }
        public Texture2D tex { get; set; }
        public float rotationSpeed { get; set; }
        public int deleteAfterX { get; set; }
        public int deleteAfterY { get; set; }
        public float xSpeed { get; set; }
        public float ySpeed { get; set; }
        private float rotationSpeedSet;


        public Wind(Vector2 position, Texture2D texture, float rotation = 0.002f, int screenWidth = 600, int screenHeight = 600, float yspeed = 0.01f, float xspeed = 5f)
        {
            this.pos = position;
            this.tex = texture;
            this.rotationSpeedSet = rotation;
            this.deleteAfterX = screenWidth;
            this.deleteAfterY = screenHeight;
            this.ySpeed = yspeed;
            this.xSpeed = xspeed;
        }


        /// <summary>
        /// Updates the wind
        /// </summary>
        public void Update()
        {
            //make the wind go sideways
            this.pos = new Vector2(this.pos.X + this.xSpeed, this.pos.Y + ySpeed);

            //configure the rotation
            this.rotationSpeed = rotationSpeed + rotationSpeedSet;

            //reset the wind particle when needed
            if (this.pos.X > deleteAfterX)
            {
                this.pos = new Vector2(0, this.pos.Y);
            }
            if (this.pos.Y > deleteAfterY)
            {
                this.pos = new Vector2(this.pos.X, 0);
            }

            //set the rectangle
            rectanglePos = new Rectangle((int)this.pos.X, (int)this.pos.Y, this.tex.Width, this.tex.Height);
        }
    }
}
